{-# LANGUAGE KindSignatures #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE RankNTypes #-}

module OkStd.Error where

import Data.Semigroup ((<>))
import qualified Data.Text as T
import qualified GHC.Err as Err
import GHC.Prim
import GHC.Stack.Types
import GHC.Types (RuntimeRep)

-- | Stops execution and displays an error message
error :: forall (r :: RuntimeRep). forall (a :: TYPE r). HasCallStack => T.Text -> a
error msg = Err.error ("error: " <> T.unpack msg)

-- | Stops execution and displays an error message
bug :: forall (r :: RuntimeRep). forall (a :: TYPE r). HasCallStack => T.Text -> a
bug msg = Err.error ("bug: " <> T.unpack msg)
