module OkStd.Foldable
  ( lookup,
  )
where

import Data.Eq (Eq, (==))
import Data.Foldable (Foldable, find)
import Data.Functor ((<$>))
import Data.Maybe (Maybe)
import Data.Tuple (fst, snd)

-- | Looks up a key in an association foldable object
lookup :: (Eq a, Foldable t) => a -> t (a, b) -> Maybe b
lookup key assoc = snd <$> find (\it -> fst it == key) assoc
